import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  ClassType,
  MetadataKeyType,
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';


export interface WebApplicationAnnotationAttributes {
  injectables?: ClassType[];
  configurations?: ClassType[];
}

export class WebApplicationAnnotation implements Annotation {
  public readonly attributes: WebApplicationAnnotationAttributes;

  public constructor(attributes: WebApplicationAnnotationAttributes) {
    this.attributes = attributes;
  }

  public classDecorator<TFunction extends Function>(target: TFunction): TFunction | void {
    console.log('WebApplication');
  }

}

export const WebApplication = Decorator.create(WebApplicationAnnotation);
